<?php
/**
* Plugin Name: ServInfo Client
* Plugin URI: https://elite-star-services.com/servinfo
* Version: 0.9.8
* Author: Elite Star Services
* Description: ServInfo Client provides Linux Server Information
*
	* @Project: 
	* ServInfo Server Information Manager
	* Web: https://elite-star-services.com/servinfo
	* Copyright © 2023 Elite Star Services
	* 
	* @Changelog:
	* https://servinfo.elite-star-services.com/sc-changelog/
	* 
	* @License:
	* GPL v3 | https://elite-star-services.com/license/
*
**/



/**
 * Plugin Activation / Add Token Entry
 */
function si_activate() { 
if (!defined('SI_TOKEN')) {

// GET SERVER ID / VERIFY LINUX
$mach = 'hostnamectl status';
exec($mach, $macout);
foreach ($macout as $key => $value) { 
    $minf = explode(": ", $value);
    $minf[0] = trim($minf[0]);
// Get Individual Items Here 
    if ($minf[0] == "Machine ID") { $sid = $minf[1]; }
//    if ($minf[0] == "Static hostname") { $host = $minf[1]; }
//    if ($minf[0] == "Virtualization") { $vm = strtoupper($minf[1]); }
//    if ($minf[0] == "Kernel") { $ker = $minf[1]; }
}

// Backup Method to Get SID
if (!$sid) { $sid = trim(shell_exec('cat /etc/machine-id 2>/dev/null')); }

// WARN AND DIE IF NO SID
if (!$sid) {
    esc_html_e( 'Cannot Get Server ID / Is Server Linux?', 'si-textdomain' ); 
    die();
} else {

// WRITE TOKEN TO WP-CONFIG
$newtok = substr($sid, 8, -8);

$fp = fopen(ABSPATH . 'wp-config.php', 'a')or die("Unable to open wp-config!");
fwrite($fp, "\r\r// Required ServInfo Setting\r");
fwrite($fp, "define('SI_TOKEN', '");
fwrite($fp, $newtok);
fwrite($fp, "');");
fclose($fp);
}
//$token = $newtok;

}
}
register_activation_hook( __FILE__, 'si_activate' );



// ADMIN AREA SERVINFO MENU
function si_admin_menu() {
    add_menu_page(
        __( 'ServInfo Main', 'si-textdomain' ),
        __( 'ServInfo', 'si-textdomain' ),
        'manage_options',
        'servinfo-main',
        'si_main_page',
        'dashicons-info'
    );
    add_submenu_page(
        'servinfo-main',
        'ServInfo Settings', //page title
        'Settings', //menu title
        'manage_options', //capability,
        'servinfo-settings',//menu slug
        'si_settings_page' //callback function
    );
}
add_action( 'admin_menu', 'si_admin_menu' );



// SETTINGS PAGE FUNCTIONS
function si_register_settings() {
//    register_setting( 'si_plugin_options', 'si_plugin_options', 'si_plugin_options_validate' );
    register_setting( 'si_plugin_options', 'si_plugin_options' );
    add_settings_section( 'api_settings', 'ServInfo Settings', 'si_plugin_section_text', 'si_plugin' );

    add_settings_field( 'si_plugin_setting_token', 'Security Token<br><small style="font-weight:normal;">Secure Token based on Machine ID</small>', 'si_plugin_setting_token', 'si_plugin', 'api_settings' );
    add_settings_field( 'si_plugin_setting_server_url', 'ServInfo Server<br><small style="font-weight:normal;">Full URL to Your ServInfo Server</small>', 'si_plugin_setting_server_url', 'si_plugin', 'api_settings' );
    add_settings_field( 'si_plugin_setting_dev_mode', 'Enable Dev Mode', 'si_plugin_setting_dev_mode', 'si_plugin', 'api_settings' );
}
add_action( 'admin_init', 'si_register_settings' );


function si_plugin_section_text() { 
    echo 'THESE SETTINGS ARE RESET ANYTIME THE PLUGIN IS DEACTIVATED'; 
//    print_r(get_option('si_plugin_options'));
}

function si_plugin_setting_token() {
    $options = get_option( 'si_plugin_options' );
    $token = SI_TOKEN;
    if (is_array($options)) { $iu_tok = $options['token']; } else { $iu_tok = $token; }

        // Update wp-config SI_TOKEN if Changed Here
        if ((is_array($options)) && ($options['token'] != $token)) { 
            $fco = file_get_contents(ABSPATH . 'wp-config.php')or die("Unable to open wp-config!");
            $db_tok = $options['token'];
            //$token = SI_TOKEN;
            //$si_token = "define('SI_TOKEN', '".$token."');";
            //$fta = str_replace('// Required ServInfo Setting', '', $fco);
            $fcn = str_replace($token, $db_tok, $fco);
            //$fcn = trim($fcn);
            file_put_contents(ABSPATH . 'wp-config.php', $fcn);
        }

    echo "<input id='si_plugin_setting_token' name='si_plugin_options[token]' type='text' value='" . esc_attr( $iu_tok ) . "' />";
}

function si_plugin_setting_server_url() {
    $options = get_option( 'si_plugin_options' );
    if (is_array($options)) { $si_db_url = esc_attr( $options['server_url'] ); } else { $si_db_url = ''; }
    echo "<input id='si_plugin_setting_server_url' name='si_plugin_options[server_url]' type='text' size='50' value='" . $si_db_url . "' />";
}

function si_plugin_setting_dev_mode() {
    $options = get_option( 'si_plugin_options' );
    if (is_array($options) && array_key_exists('dev_mode', $options)) { $si_db_dev = esc_attr( $options['dev_mode'] ); } else { $si_db_dev = '0'; }
    echo "<input id='si_plugin_setting_dev_mode' name='si_plugin_options[dev_mode]' type='checkbox' value='1'" . checked( 1, $si_db_dev, false ) . " />";
}

function si_settings_page() {
    ?>
    <form action="options.php" method="post">
        <?php 
        settings_fields( 'si_plugin_options' );
        do_settings_sections( 'si_plugin' ); ?><hr>
        <input name="submit" class="button button-primary" type="submit" value="<?php esc_attr_e( 'Save Settings' ); ?>" />  
        _ <a class="button-secondary" href="https://elite-star-services.com/wordpress-development/">Visit Elite Star Services</a>
    </form>
    <?php
}



// MAIN FUNCTION CALL - SHOW SERVINFO CLIENT
function si_main_page() {

    $options = get_option( 'si_plugin_options' );
    
    // SERVINFO SERVER ADDRESS
    global $si_url;
    if (isset($options['server_url'])) {
    	$si_url = $options['server_url'];
    } else {
    	$si_url="";
    }

    // DEV MODE CONTROL
    if (isset($options['dev_mode'])) {
        $devMode = "TRUE";
    }

    // LOAD SERVINFO HERE
    require 'servinfo.php';

}



/**
 * Plugin Deactivation / Remove Token Entry
 */
function si_deactivate() {
    $fco = file_get_contents(ABSPATH . 'wp-config.php')or die("Unable to open wp-config!");
    $token = SI_TOKEN;
    $si_token = "define('SI_TOKEN', '".$token."');";
    $fta = str_replace('// Required ServInfo Setting', '', $fco);
    $fcn = str_replace($si_token, '', $fta);
    $fcn = trim($fcn);
    file_put_contents(ABSPATH . 'wp-config.php', $fcn);
    delete_option('si_plugin_options'); 
}
register_deactivation_hook( __FILE__, 'si_deactivate' );




/* Function that runs when Shortcode is called - EXAMPLE / NOT USED 
function serv_info() { 
	
    //$onPage = '<hr>ServInfo Lite for WordPress Beta Testing...<hr>'; 
    $onPage = include('ServTest.php');
    //$onPage = include('servinfo.php');
    $onPage = substr($onPage, 1);
      
    // Output that needs to be returned
    return $onPage;
}
// Register Shortcode
add_shortcode('servinfo', 'serv_info');
*/




// Check for ServInfo Client Update
    require 'assets/bh-update/plugin-update-checker.php';
    use YahnisElsts\PluginUpdateChecker\v5\PucFactory;
    $MyUpdateChecker = PucFactory::buildUpdateChecker(
        'https://cs.elite-star-services.com/wp-repo/?action=get_metadata&slug=serv-info', //Metadata URL.
        __FILE__, //Full path to the main plugin file.
        'serv-info' //Plugin slug. Usually it's the same as the name of the directory.
    );
?>